const Promise    = require("promise");
const fs         = require("fs");
const express    = require("express");
const body       = require("body-parser");
const helmet     = require("helmet");
const nodemailer = require("nodemailer");
const utils      = require("./Utils");
const Captcha    = require("./Captcha");

var transporter = nodemailer.createTransport({
        host: 'ssl0.ovh.net',
        port: 465 ,
        secure: true, // true for 465, false for other ports
        auth: {
            user: 'postmaster@emilianomaccaferri.com',
            pass: 'pollo3c0c41na'
        }
})

var Router = function(port){

  this.port = port;
  this.app = express();
  this.app.use(helmet())
  this.app.enable('trust proxy');
  this.app.disable('x-powered-by');
  this.app.use(body.json());
  this.app.use(body.urlencoded({extended: true}));
  this.app.set('views', __dirname + '/../views');
  this.app.set('view engine', 'twig');
  this.app.use('/static', express.static(__dirname + '/../assets'))
  this.app.listen(this.port);
  this.init = () => {

    return new Promise(

      (resolve, reject) => {

        this.app.get('/', (req, res) => {

            res.render('index', {title: 'Homepage'})

        })

        this.app.get('/tour-dates', (req, res) => {

          res.render('events', {title: 'Tour dates'})

        })

        this.app.post('/send', (req, res) => {

            var email = req.body.email,
                name = req.body.name,
                subject = req.body.subject,
                message = req.body.message,
                response = req.body.captcha;

            var captcha = new Captcha("6LeVVmQUAAAAAOOjaLVsj2nwcunJP_vWkIGGOS-B", response);

            if(!email || !name || !subject || !message || !response){

              res.status(400);
              return res.json({error: "missing_parameter"});

            }

            captcha
            .verify()
            .then(ok => {

              var options = {

                from: '"Notifications" <postmaster@emilianomaccaferri.com>',
                to: 'tom@thomasdeil.com',
                subject: subject.toString('utf8'),
                text: message.toString('utf8'),
                html: '<style>@import url("https://fonts.googleapis.com/css?family=Roboto:400,700"); * {font-family: "Roboto"} h1{font-weight: lighter; font-size: 2.5em;} p{font-weight: lighter; padding: 30px; background: #DADADA;}</style><h1 style="font-weight: lighter; font-size: 2.5em;">New email</h1><br>'
                +
                'From: ' + name + ' (' + email + ')<br>'+message.replace(/\n/g, '<br>')+'</p>'

              };

              transporter.sendMail(options, (err, info) => {

                if(err) return reject({error: 'fatal'});

                return res.json({success: true})

              })
            })
            .catch(err => {

              res.status(400);
              res.json(err);

            })

        })

      }

    )

  }

}

module.exports = Router;
